app/models/__init__.py
from .models import Post, Tag, PostTagLink, User

__all__ = [
    'User',
    'Post',
    'Tag',
    'PostTagLink',
]

app/models/database.py
from flask_sqlalchemy import SQLAlchemy

db = SQLAlchemy()

__all__ = [
    'db',
]

app/models/models.py
from werkzeug.exceptions import NotFound

from models.database import db
from sqlalchemy import Column, Integer, String, Text, \
    DateTime, ForeignKey, Boolean
from sqlalchemy.orm import relationship
from sqlalchemy.sql import func


class User(db.Model):
    """
    Таблица "Пользователи"
    """
    __tablename__ = "users"

    id = Column(Integer, primary_key=True)
    username = Column(String(50), unique=True, nullable=False)
    firstname = Column(String(50), nullable=False)
    lastname = Column(String(50), nullable=False)

    user_posts = relationship("Post",
                              back_populates="user",
                              cascade="all, delete",
                              passive_deletes=True)

    def __str__(self):
        return f"{self.firstname} {self.lastname}"


class Post(db.Model):
    """
    Таблица "Посты"
    """
    __tablename__ = "posts"

    id = Column(Integer, primary_key=True)
    title = Column(String(250), nullable=False)
    description = Column(Text, nullable=False)
    in_archive = Column(Boolean, server_default="0")
    created_at = Column(DateTime, server_default=func.now())
    updated_at = Column(DateTime, server_default=func.now())
    user_id = Column(Integer, ForeignKey("users.id", ondelete='CASCADE'), nullable=False)
    user = relationship("User", back_populates="user_posts")

    post_links = relationship("PostTagLink",
                              back_populates="post_link",
                              cascade="all, delete",
                              passive_deletes=True)

    @classmethod
    def get_post_by_id(cls, post_id: int, exclude_archive: bool = True):
        """
        Поиск поста по его ID (post_id)

        :param post_id: ID записи
        :param exclude_archive:
            признак включать или не включать в поиск архивные записи
        """
        if exclude_archive:
            post = cls.query.filter_by(in_archive=False, id=post_id).one_or_none()
        else:
            post = cls.query.filter_by(id=post_id).one_or_none()

        if post is None:
            raise NotFound(f"Пост не найден (ID: \"{post_id}\")")
        return post

    def __str__(self):
        return f"{self.title}"

    def __repr__(self):
        return self.__str__()


class Tag(db.Model):
    """
    Таблица "Тэги"
    """
    __tablename__ = "tags"

    id = Column(Integer, primary_key=True)
    name = Column(String(40), unique=True, nullable=False)
    created_at = Column(DateTime, server_default=func.now())

    tag_links = relationship("PostTagLink",
                             back_populates="tag_link",
                             cascade="all, delete",
                             passive_deletes=True)

    @classmethod
    def get_tag_by_id(cls, tag_id: int):
        """
        Поиск тега по его ID (tag_id)

        :param tag_id: ID записи
        """
        tag = cls.query.filter_by(id=tag_id).one_or_none()

        if tag is None:
            raise NotFound(f"Пост не найден (ID: \"{tag_id}\")")
        return tag

    def __str__(self):
        return f"{self.name}"


class PostTagLink(db.Model):
    """
    Таблица связей "Пост-Тэг"
    Для реализации связи многие-ко-многим
    """
    __tablename__ = "post_tag_links"

    post_id = Column(Integer, ForeignKey("posts.id", ondelete='CASCADE'), primary_key=True)
    tag_id = Column(Integer, ForeignKey("tags.id", ondelete='CASCADE'), primary_key=True)
    created_at = Column(DateTime, server_default=func.now())

    post_link = relationship("Post", back_populates="post_links")
    tag_link = relationship("Tag", back_populates="tag_links")

app/app.py
from main import app

if __name__ == '__main__':
    app.run(host='localhost', debug=True, port=5000)

app/main.py
import config
from models.database import db
from flask import Flask, render_template
from flask_migrate import Migrate
from views.posts import post_app
from views.tags import tag_app
from views.users import user_app

# создание приложения и подключение дополнений (дополнительных приложений)
app = Flask(__name__)
app.register_blueprint(user_app, url_prefix="/users")
app.register_blueprint(post_app, url_prefix="/posts")
app.register_blueprint(tag_app, url_prefix="/tags")

# подключение к БД
app.config.update(
    SQLALCHEMY_DATABASE_URI=config.SQLALCHEMY_DATABASE_URI,
    SQLALCHEMY_TRACK_MODIFICATIONS=False
)
db.init_app(app)
Migrate(app, db, 'models/migrations')


@app.route("/", endpoint="index")
def index():
    return render_template("index.html")


# Команда не актуальная после подключения Flask-Migrate
# @app.cli.command("init-db", with_appcontext=True)
# def initialize_db():
#     """
#     Falsk-команда для инициализации базы данных
#     Создаёт базу данных и структуру таблиц
#     """
#     print('Start DB-init process')
#     db.create_all()
#     print('DB-init process finished')


if __name__ == "__main__":
    app.run(host='localhost', debug=True, port=5000)

app/views/posts.py
from flask import Blueprint, render_template, request, redirect, url_for
from models import Post, User
from models.database import db
from werkzeug.exceptions import Unauthorized

post_app = Blueprint("post_app", __name__)


@post_app.route("/", endpoint="posts")
def posts_list():
    posts = Post.query.filter_by(in_archive=False)
    return render_template("blog/posts_list.html", data=posts, data_length=posts.count())


@post_app.route("/<int:post_id>/", endpoint="post_detail")
def post_detail(post_id):
    post = Post.get_post_by_id(post_id)
    return render_template("blog/post.html", post=post)


@post_app.route("/<int:post_id>/archive", methods=["POST"], endpoint="archive_post")
def archive_post(post_id):
    post = Post.get_post_by_id(post_id)
    post.in_archive = True
    db.session.commit()

    return redirect(url_for("post_app.posts"))


@post_app.route("add/", methods=['POST', 'GET'], endpoint="add_post")
def add_post():
    if request.method == "GET":
        users = User.query.all()
        return render_template("blog/add_post.html", users=users)

    form = request.form
    title = form.get("post_title")
    description = form.get("post_description")
    user_id = form.get("post_author")

    if user_id is None:
        raise Unauthorized(
            "Ошибка создания поста! Авторизуйтесь и попробуйте снова.")

    # создаём пост и сохраняем его в базу данных
    post = Post(
        title=title,
        description=description,
        user_id=user_id)
    db.session.add(post)
    db.session.commit()

    return redirect(url_for("post_app.posts"))

app/views/tags.py
from flask import Blueprint, render_template, request, redirect, url_for
from models import Tag
from models.database import db

tag_app = Blueprint("tag_app", __name__)


@tag_app.route("/", endpoint="tags")
def tags_list():
    tags = Tag.query.all()
    return render_template("tags/tags_list.html", data=tags)


@tag_app.route("/<int:tag_id>/", endpoint="tag_detail")
def tag_details(tag_id):
    tag = Tag.get_tag_by_id(tag_id)
    return render_template("tags/tag.html", tag=tag)


@tag_app.route("/<int:tag_id>/delete", methods=["POST"], endpoint="delete_tag")
def archive_post(tag_id):
    tag = Tag.get_tag_by_id(tag_id)
    db.session.delete(tag)
    db.session.commit()

    return redirect(url_for("tag_app.tags"))


@tag_app.route("add/", methods=['POST', 'GET'], endpoint="add_tag")
def add_tag():
    if request.method == "GET":
        return render_template("tags/add_tag.html")

    form = request.form
    name = form.get("tag_name")

    tag = Tag(name=name)
    db.session.add(tag)
    db.session.commit()

    return redirect(url_for("tag_app.tags"))

app/views/users.py
from flask import Blueprint, render_template, request, redirect, url_for
from models import User
from models.database import db

user_app = Blueprint("user_app", __name__)


@user_app.route("users/", endpoint="users")
def users_list():
    users = User.query.all()
    return render_template("users/users_list.html", data=users)


@user_app.route("add/", methods=['POST', 'GET'], endpoint="add_user")
def add_user():
    if request.method == "GET":
        return render_template("users/add_user.html")

    form = request.form
    username = form.get("username")
    firstname = form.get("firstname")
    lastname = form.get("lastname")

    user = User(
        username=username,
        firstname=firstname,
        lastname=lastname
    )
    db.session.add(user)
    db.session.commit()

    return redirect(url_for("index"))

app/templates/blog/add_post.html
{% extends 'layout.html' %}

{% block title %}
    Добавление нового поста
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
            <li class="breadcrumb-item"><a href="{{ url_for("post_app.posts") }}">Список постов</a></li>
        </ol>
    </nav>
    <h1>Новый пост</h1>
    <form method="post">
        <div class="mb-3">
            <label for="postTitle" class="form-label">Заголовок</label>
            <input type="text" class="form-control" id="postTitle" name="post_title">
        </div>
        <div class="mb-3">
            <label for="postDescription" class="form-label">Описание</label>
            <textarea class="form-control" id="postDescription" rows="3" name="post_description"></textarea>
        </div>
        <div class="mb-3">
            <label for="postAuthor" class="form-label">Автор</label>
{#            <input type="text" class="form-control" id="postTitle" name="post_title">#}
            <select class="form-control" id="postAuthor" name="post_author" method="GET" action="/">
                {% for user in users %}
                    <option value="{{ user.id }}">{{ user }}</option>
                {% endfor %}
            </select>
        </div>
        <button type="submit" class="btn btn-primary">Сохранить</button>
    </form>
{% endblock %}

app/templates/blog/post.html
{% extends 'layout.html' %}

{% block title %}
    {{ post.title }}
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
            <li class="breadcrumb-item"><a href="{{ url_for("post_app.posts") }}">Список постов</a></li>
        </ol>
    </nav>
    <h1>{{ post.title }}</h1>
    <p>{{ post.description }}</p>
    <p>
        <small class="text-muted">Создан: {{ post.created_at.strftime('%Y-%m-%d %H:%M') }}</small>
        <code>Автор: {{ post.user }}</code>
    </p>
    <form action="archive" method="post">
        <button class="btn btn-danger">Архивировать</button>
    </form>
{% endblock %}

app/templates/blog/posts_list.html
{% extends 'layout.html' %}

{% block title %}
    Мой блог
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
        </ol>
    </nav>
    <div style="margin-bottom: 5pt;">
        <h2>Список постов</h2>
        <div>
            <a class="btn btn-success" href="{{ url_for("post_app.add_post") }}">Создать пост</a>
        </div>
        {% for post_row in data|batch(2) %}
            <div class="row">
                {% for post  in post_row %}
                    <div class="card m-2 p-0" style="width: 40em;">
                        <div class="card-header">{{ post.title }}</div>
                        <div class="card-body">
                            <p class="card-text">
                                {% if post.description|length > 20 %}
                                    {{ post.description[:20] }}...
                                {% else %}
                                    {{ post.description }}
                                {% endif %} </p>
                            <p class="card-text">
                                <a href="{{ url_for("post_app.post_detail", post_id=post.id) }}" class="card-link">Читать
                                    далее</a>
                            </p>
                            <p class="card-text">
                                <small class="text-muted">{{ post.created_at.strftime("%d.%m.%Y") }}, {{ post.user }}</small>
                            </p>
                        </div>
                    </div>
                {% endfor %}
            </div>
        {% endfor %}
    </div>
    {% if data_length > 4 %}
        <div>
            <a class="btn btn-success" href="{{ url_for("post_app.add_post") }}">Создать пост</a>
        </div>
    {% endif %}
{% endblock %}

app/templates/index.html
{% extends 'layout.html' %}

{% block title %}
    Главная страница
{% endblock %}

{% block container %}
    <h3>Создать <a href="{{ url_for("user_app.add_user") }}">пользователя</a></h3>
    <h3>Читать <a href="{{ url_for("post_app.posts") }}">блог</a>
        <span class="small text-muted">(не забудьте сначала добавить пользователя)</span>
    </h3>
    <h3>Посмотреть <a href="{{ url_for("tag_app.tags") }}">список тегов</a></h3>
{% endblock %}

app/templates/layout.html
<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    {#    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">#}
    <link rel="stylesheet" href="{{ url_for("static", filename="css/bootstrap.min.css") }}">

    <title>{% block title %}
        Title
    {% endblock %}</title>
</head>
<body>
{% block menu %}
    <nav class="navbar navbar-expand-md navbar-light" style="background-color: #f7f7f7;">
        <div class="container-fluid">
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false"
                    aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
                <div class="navbar-nav">
                    <a class="nav-link active" href="{{ url_for("index") }}">Главная</a>
                    <a class="nav-link" href="{{ url_for("post_app.posts") }}">Блог</a>
                    <a class="nav-link" href="{{ url_for("tag_app.tags") }}">Теги</a>
                </div>
            </div>
        </div>
    </nav>
{% endblock %}

<div class="container pt-3">
    {% block container %}

    {% endblock %}
</div>

{% block footer %}

{% endblock %}


<script src="{{ url_for("static", filename="js/bootstrap.bundle.min.js") }}"></script>
<!-- Optional JavaScript; choose one of the two! -->

<!-- Option 1: Bootstrap Bundle with Popper -->
{#    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>#}

<!-- Option 2: Separate Popper and Bootstrap JS -->
<!--
<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.5.4/dist/umd/popper.min.js" integrity="sha384-q2kxQ16AaE6UbzuKqyBE9/u/KzioAlnx2maXQHiDX9d4/zp8Ok3f+M7DPm+Ib6IU" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.min.js" integrity="sha384-pQQkAEnwaBkjpqZ8RU1fF1AKtTcHJwFl3pblpTlHXybJjHpMYo79HY3hIi4NKxyj" crossorigin="anonymous"></script>
-->
</body>
</html>

app/templates/tags/add_tag.html
{% extends 'layout.html' %}

{% block title %}
    Добавление нового тега
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
            <li class="breadcrumb-item"><a href="{{ url_for("tag_app.tags") }}">Теги</a></li>
        </ol>
    </nav>
    <h1>Новый тег</h1>
    <form method="post">
        <div class="mb-3">
            <label for="tagName" class="form-label">Название</label>
            <input type="text" class="form-control" id="tagName" name="tag_name">
        </div>
        <button type="submit" class="btn btn-primary">Сохранить</button>
    </form>
{% endblock %}

app/templates/tags/tag.html
{% extends 'layout.html' %}

{% block title %}
    Тег - {{ tag.name }}
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
            <li class="breadcrumb-item"><a href="{{ url_for("tag_app.tags") }}">Теги</a></li>
        </ol>
    </nav>
    <h3>Просмотр тега</h3>
    <p>{{ tag.name }}</p>
    <form action="delete" method="post">
        <button class="btn btn-danger">Удалить</button>
    </form>
{% endblock %}

{% block footer %}
{% endblock %}

app/templates/tags/tags_list.html
{% extends 'layout.html' %}

{% block title %}
    Список тегов
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
        </ol>
    </nav>

    <div>
        <h2>Список тегов</h2>
        <ul>
            {% for tag in data %}
                <li>
                    <a href="{{ url_for("tag_app.tag_detail", tag_id=tag.id) }}">{{ tag.name }}</a>
                </li>
            {% endfor %}
        </ul>
        <div>
            <a href="{{ url_for("tag_app.add_tag") }}" class="btn btn-success">Новый тег</a>
        </div>
    </div>
{% endblock %}

app/templates/users/add_user.html
{% extends 'layout.html' %}

{% block title %}
    Добавление нового пользователя
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
{#            <li class="breadcrumb-item"><a href="{{ url_for("user_app.users") }}">Список пользователей</a></li>#}
        </ol>
    </nav>
    <h1>Новый пользователь</h1>
    <form method="post">
        <div class="mb-3">
            <label for="username" class="form-label">Логин пользователя</label>
            <input type="text" class="form-control" id="username" name="username"/>
        </div>
        <div class="mb-3">
            <label for="lastname" class="form-label">Фамилия</label>
            <input type="text" class="form-control" id="lastname" name="lastname"/>
        </div>
        <div class="mb-3">
            <label for="firstname" class="form-label">Имя</label>
            <input type="text" class="form-control" id="firstname" name="firstname"/>
        </div>
        <button type="submit" class="btn btn-primary">Добавить</button>
    </form>
</select>
{% endblock %}

app/templates/users/users_list.html
{% extends 'layout.html' %}

{% block title %}
    Список пользователей
{% endblock %}

{% block container %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url_for("index") }}">Главная</a></li>
        </ol>
    </nav>

    <div>
        <h2>Список тегов</h2>
        <ul>
            {% for user in data %}
                <li>
{#                    <a href="{{ url_for("user_app.user_detail", user_id=user.id) }}">{{ user.name }}</a>#}
                    {{ user.name }}
                </li>
            {% endfor %}
        </ul>
        <div>
            <a href="{{ url_for("user_app.user_tag") }}" class="btn btn-success">Новый пользователь</a>
        </div>
    </div>
{% endblock %}